#include "iom16.h"
#define a 1   //    ,  ,
#define b 2   //   ,   "" 
#define c 4   // ,      
#define d 128 //   .  ,  
#define e 64  // -   ,    
#define f 32  //  255     .
#define g 16  //        .
#define DP 8  //   ,     ""

short unsigned int i = 1;
unsigned char DigNumber = 0;
unsigned char Dig[10]; // ,    ,  
//     ,    ,  
//  .     .

void io_init()
{
  DDRD = 0xFF;  //   D  
  PORTD = 0xFF;
}

void timer0_init()
{
  OCR0 = 15;  //    1024 .  
  // 1024*16 .
  TCCR0 |= (1 << WGM01) | (1 << CS00) | (1 << CS02);
  TIMSK |= (1 << OCIE0);
}

void Dig_init()
{
  Dig[0] = 255 - (a+b+c+d+e+f);   //     ,
  Dig[1] = 255 - (b+c);           //     
  Dig[2] = 255 - (a+b+g+e+d);     // 255.    , 
  Dig[3] = 255 - (a+b+g+c+d);     //   .
  Dig[4] = 255 - (f+g+b+c);       //   
  Dig[5] = 255 - (a+f+g+c+d);     //   
  Dig[6] = 255 - (a+f+g+c+d+e);
  Dig[7] = 255 - (a+b+c);
  Dig[8] = 255 - (a+b+c+d+e+f+g);
  Dig[9] = 255 - (a+b+c+d+f+g);
}

void main()
{
  io_init();
  timer0_init();
  Dig_init();
  SREG |= (1 << 7);
  PORTD = Dig[0];   //    "0"
  while(1)
  {}
}

#pragma vector = TIMER0_COMP_vect
__interrupt void Indic_change()
{
  if (i < 675)  // 675*16*1024 = 11,0592 
  {             //      
    i++;
  }
  else
  {
    i = 1;
    if (DigNumber < 9)
      DigNumber++;
    else
      DigNumber = 0;
    PORTD = Dig[DigNumber];
  }
}
